"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _getQueryPaths = _interopRequireDefault(require("./getQueryPaths"));
var _utils = require("./utils");
var _excluded = ["variables"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw new Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw new Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function initState(_pageSize) {
  return {
    pageSize: _pageSize,
    intentionPageNum: 1,
    intensionCursorAfter: null,
    timestamp: 0,
    loading: true,
    error: null,
    // loadingFirst: true

    pageNum: null,
    hasPrevPage: null,
    hasNextPage: null,
    arPageNums: [],
    arCursorAfter: [],
    data: null,
    //dataPage
    // dataAll: null,
    pageInfo: null,
    lastPageNum: null
  };
}
function reducer(state, action) {
  switch (action.type) {
    case "setPageNext":
      {
        var intentionPageNum = state.pageNum + 1;
        var intensionCursorAfter = state.pageNum === state.arPageNums.length ? state.pageInfo.endCursor : state.arCursorAfter[intentionPageNum - 1];
        // todo:
        //   get cursor of last item on the page

        // if (process.env.NODE_ENV==='development') {
        //   console.log(`reducer setPageNext ${intentionPageNum}`);
        // }  

        // if (intentionPageNum <= state.arPageNums.length) {

        //   const pageNum = intentionPageNum;
        // const pageSize = state.pageSize
        //   const dataPage = state.dataAll.slice((pageNum - 1) * pageSize, pageNum * pageSize);

        //   let hasNextPage = true;
        //   if (state.lastPageNum) {
        //     hasNextPage = pageNum < state.lastPageNum;
        //   }

        //   return {
        //     ...state,
        //     pageNum,
        //     hasNextPage,
        //     hasPrevPage: 1 < pageNum,
        //     data: dataPage
        //   };
        // }

        return _objectSpread(_objectSpread({}, state), {}, {
          intentionPageNum: intentionPageNum,
          intensionCursorAfter: intensionCursorAfter,
          // loading: true,
          loading: state.arPageNums.length < intentionPageNum,
          error: null,
          //to repeat after Error
          timestamp: Date.now()
        });
      }
    case "setPagePrev":
      {
        var _intentionPageNum = state.pageNum - 1;
        var _intensionCursorAfter = state.arCursorAfter[_intentionPageNum - 1];

        // if (process.env.NODE_ENV==='development') {
        //   console.log(`reducer setPagePrev ${intentionPageNum}`);
        // }  

        return _objectSpread(_objectSpread({}, state), {}, {
          intentionPageNum: _intentionPageNum,
          intensionCursorAfter: _intensionCursorAfter,
          // loading: true,
          loading: false,
          error: null
        });
        // const pageNum = intentionPageNum;
        // const pageSize = state.pageSize
        // const dataPage = state.dataAll.slice((pageNum - 1) * pageSize, pageNum * pageSize);

        // let hasNextPage = true;
        // if (state.lastPageNum) {
        //   hasNextPage = pageNum < state.lastPageNum;
        // }

        // return {
        //   ...state,
        //   pageNum,
        //   hasPrevPage: 1 < pageNum,
        //   hasNextPage,
        //   data: dataPage
        // };
      }
    case "setPage":
      {
        var _intentionPageNum2 = action.payload;
        var _intensionCursorAfter2 = state.arCursorAfter[_intentionPageNum2 - 1];
        // if (process.env.NODE_ENV==='development') {
        //   console.log(`reducer setPagePrev ${intentionPageNum}`);
        // }  

        return _objectSpread(_objectSpread({}, state), {}, {
          intentionPageNum: _intentionPageNum2,
          intensionCursorAfter: _intensionCursorAfter2,
          // loading: true,
          loading: false,
          error: null
        });
      }
    case "success":
      var _action$payload = action.payload,
        data = _action$payload.data,
        pageInfo = _action$payload.pageInfo;
      var pageSize = state.pageSize;
      //if intentional page is empty, dont go to intensional page
      var pageNum = state.intentionPageNum;
      var arPageNums = state.arPageNums.length < pageNum ? state.arPageNums.concat([pageNum]) : state.arPageNums;
      var arCursorAfter = state.arPageNums.length < pageNum ? state.arCursorAfter.concat([state.intensionCursorAfter]) : state.arCursorAfter;
      // console_log('data')
      // console_log(data)
      var dataPage = data.slice((pageNum - 1) * pageSize, pageNum * pageSize);

      //let hasNextPage = (pageNum === arPageNums.length && pageInfo.hasNextPage) || pageNum < arPageNums.length
      //const hasNextPage = pageNum < arPageNums.length || (pageNum === arPageNums.length && pageInfo.hasNextPage)
      var hasNextPage = true;
      var lastPageNum = state.lastPageNum;
      if (state.lastPageNum) {
        hasNextPage = pageNum < state.lastPageNum;
      } else if (dataPage.length < pageSize) {
        hasNextPage = false;
        lastPageNum = pageNum;
      }
      if (Array.isArray(dataPage) && dataPage.length === 0) {
        return _objectSpread(_objectSpread({}, state), {}, {
          loading: false,
          hasNextPage: false,
          lastPageNum: state.pageNum
        });
      }
      return _objectSpread(_objectSpread({}, state), {}, {
        loading: false,
        pageNum: pageNum,
        arPageNums: arPageNums,
        arCursorAfter: arCursorAfter,
        hasPrevPage: 1 < pageNum,
        hasNextPage: hasNextPage,
        data: dataPage,
        // dataAll: data,
        pageInfo: pageInfo,
        lastPageNum: lastPageNum
      });
    case "error":
      // if (process.env.NODE_ENV==='development') {
      //   console.log("reducer: error");
      // }  

      return _objectSpread(_objectSpread({}, state), {}, {
        error: action.payload,
        loading: false
        // bad option: becouse
        // intensionCursorAfter: (state.pageNum && state.arCursorAfter[state.pageNum]) || null

        // // ?set lastPageNum on error
        // hasNextPage: false,
        // lastPageNum: state.pageNum
      });
    default:
      throw new Error("usePagination/reducer(): Unknown action.type ".concat(action.type));
  }
}
function usePagination(client, options, pageSize) {
  var refCached = (0, _react.useRef)({});
  var _useReducer = (0, _react.useReducer)(reducer, initState(pageSize)),
    _useReducer2 = _slicedToArray(_useReducer, 2),
    state = _useReducer2[0],
    dispatch = _useReducer2[1];
  var memoOptions = (0, _react.useMemo)(function () {
    // if (process.env.NODE_ENV==='development') {
    //   console.log('useMemo memoRestOptions')
    // }      
    var variables = options.variables,
      restOptions = _objectWithoutProperties(options, _excluded);
    return _objectSpread({
      variables: variables || {}
    }, restOptions);
  },
  // eslint-disable-next-line
  (0, _utils.options2arr)(options));
  var _useMemo = (0, _react.useMemo)(function () {
      return (0, _getQueryPaths["default"])(memoOptions.query);
    }, [memoOptions.query]),
    fnJoinResults = _useMemo.fnJoinResults,
    fnGetArray = _useMemo.fnGetArray,
    fnGetPageInfo = _useMemo.fnGetPageInfo;
  var observableQuery = (0, _react.useMemo)(function () {
    var _observable;
    try {
      _observable = client.watchQuery(_objectSpread(_objectSpread({}, memoOptions), {}, {
        variables: _objectSpread(_objectSpread({}, memoOptions.variables), {}, {
          after: null,
          first: pageSize
        }),
        fetchPolicy: "network-only"
      }));
      refCached.current = {
        "null": true
      };
    } catch (errWatch) {
      dispatch({
        type: "error",
        payload: errWatch
      });
    }
    return _observable;
  }, [client, memoOptions, pageSize]);
  (0, _react.useEffect)(function () {
    if (!observableQuery) {
      return;
    }
    var s = observableQuery.subscribe(function (result) {
      dispatch({
        type: "success",
        payload: {
          data: fnGetArray(result.data),
          pageInfo: fnGetPageInfo(result.data)
        }
      });
    }, function (errSubscr) {
      dispatch({
        type: "error",
        payload: errSubscr
      });
    });
    return function () {
      return s.unsubscribe();
    };
  }, [observableQuery, fnGetArray, fnGetPageInfo]);
  (0, _react.useEffect)(function () {
    function asyncFunctionInEffect() {
      return _asyncFunctionInEffect.apply(this, arguments);
    }
    function _asyncFunctionInEffect() {
      _asyncFunctionInEffect = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var prevData, isQueryCached, _options, result, strVaribles, currData;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (state.timestamp) {
                _context.next = 2;
                break;
              }
              return _context.abrupt("return");
            case 2:
              _context.prev = 2;
              prevData = client.readQuery({
                query: memoOptions.query
              });
              isQueryCached = state.intensionCursorAfter ? state.intensionCursorAfter in refCached.current : "null" in refCached.current;
              if (!isQueryCached) {
                _context.next = 8;
                break;
              }
              //- it will be processed in reduce
              dispatch({
                type: "success",
                payload: {
                  data: fnGetArray(prevData),
                  pageInfo: fnGetPageInfo(prevData)
                }
              });
              return _context.abrupt("return");
            case 8:
              _options = _objectSpread(_objectSpread({}, memoOptions), {}, {
                variables: _objectSpread(_objectSpread({}, memoOptions.variables), {}, {
                  first: pageSize,
                  after: state.intensionCursorAfter
                }),
                // fetchPolicy: 'network-only',
                fetchPolicy: 'no-cache'
              });
              _context.next = 11;
              return client.query(_options);
            case 11:
              result = _context.sent;
              strVaribles = state.intensionCursorAfter ? state.intensionCursorAfter : "null";
              refCached.current[strVaribles] = true;
              currData = result.data;
              fnJoinResults(currData, prevData);
              client.writeQuery({
                query: memoOptions.query,
                data: currData
              });
              _context.next = 22;
              break;
            case 19:
              _context.prev = 19;
              _context.t0 = _context["catch"](2);
              dispatch({
                type: "error",
                payload: _context.t0
              });
            case 22:
            case "end":
              return _context.stop();
          }
        }, _callee, null, [[2, 19]]);
      }));
      return _asyncFunctionInEffect.apply(this, arguments);
    }
    asyncFunctionInEffect();
    // }, [state.intensionCursorAfter, pageSize, variables]);
  }, [client, memoOptions, pageSize, fnGetArray, fnGetPageInfo, fnJoinResults, state.intensionCursorAfter, state.timestamp]);
  var goNextPage = function goNextPage() {
    if (state.loading) {
      return;
    }
    if (!state.hasNextPage) {
      return;
    }
    dispatch({
      type: "setPageNext"
    });
  };
  var goPrevPage = function goPrevPage() {
    if (state.loading) {
      return;
    }
    if (!state.hasPrevPage) {
      return;
    }
    dispatch({
      type: "setPagePrev"
    });
  };
  var goPage = function goPage(_pageNum) {
    if (state.loading) {
      return;
    }
    if (!_pageNum) {
      return;
    }
    if (!(0 < _pageNum && _pageNum <= state.arPageNums.length)) {
      return;
    }
    dispatch({
      type: "setPage",
      payload: _pageNum
    });
  };
  return {
    loading: state.loading,
    error: state.error,
    data: state.data,
    //dataAll,
    //dataPage,
    hasPrevPage: state.hasPrevPage,
    goPrevPage: goPrevPage,
    hasNextPage: state.hasNextPage,
    goNextPage: goNextPage,
    goPage: goPage,
    arPageNums: state.hasNextPage,
    pageNum: state.pageNum
    // ?fnRefetchFistPage
  };
}
;
var _default = exports["default"] = usePagination;