"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.options2arr = options2arr;
var _excluded = ["query", "variables"];
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function options2arr(options) {
  var query = options.query,
    variables = options.variables,
    rest = _objectWithoutProperties(options, _excluded);
  var arr = [query];
  if (variables) {
    var arVarKeys = Object.keys(variables);
    if (arVarKeys.length) {
      var arrVar = arVarKeys.map(function (key) {
        return variables[key];
      });
      arr = arr.concat(arrVar);
    }
    var arRestKeys = Object.keys(rest);
    if (arRestKeys.length) {
      var arrRest = arRestKeys.map(function (key) {
        return rest[key];
      });
      arr = arr.concat(arrRest);
    }
  }
  return arr;
}